// -------------------------------------------------------------------------------
// 
// 		cwCu		chvO
// 
// 				Ver 3.19f
// 
// -------------------------------------------------------------------------------

// cwCu쐬p`
#define __DX_MAKE

#include "DxInput.h"

#ifndef DX_NON_INPUT

// CN[h ------------------------------------------------------------------
#include "DxLib.h"
#include "DxSystem.h"
#include "DxLog.h"

#ifndef DX_NON_NAMESPACE

namespace DxLib
{

#endif // DX_NON_NAMESPACE

// }N` -------------------------------------

// \̒` --------------------------------------------------------------------

// 萔` ----------------------------------------------------------------------

// ϐ錾 --------------------------------------------------------------

// ̓VXepf[^
INPUTSYSTEMDATA InputSysData ;

// ֐vg^Cv錾-----------------------------------------------------------

static	int UpdateJoypadInputState( int padno ) ;								// pbh̓͏Ԃ̍XV

// vO --------------------------------------------------------------------

// ̓VXȅAI֐

// ̓VXe
extern int InitializeInputSystem( void )
{
	// ɏĂ牽ɏI
	if( InputSysData.InitializeFlag )
	{
		return 0 ;
	}

	// tO𗧂Ă
	InputSysData.InitializeFlag = TRUE ;

	// ˑ
	if( InitializeInputSystem_PF_Timing0() != 0 )
	{
		// tO|
		InputSysData.InitializeFlag = FALSE ;

		return -1 ;
	}

	// POV ͖̏ԂɂĂ
	{
		int i ;
		int j ;

		for( i = 0 ; i < MAX_JOYPAD_NUM ; i ++ )
		{
			for( j = 0 ; j < 4 ; j ++ )
			{
				InputSysData.Pad[ i ].State.POV[ j ] = 0xffffffff ;
			}
		}
	}

	// I
	return 0 ;
}

// ̓VXe̎gpI
extern int TerminateInputSystem( void )
{
	// ɌnIĂ牽ɏI
	if( InputSysData.InitializeFlag == FALSE )
	{
		return 0 ;
	}

	// ˑ
	if( TerminateInputSystem_PF_Timing0() != 0 )
	{
		return -1 ;
	}

	// tO|
	InputSysData.InitializeFlag = FALSE ;

	// I
	return 0 ;
}

// WCpbh̃ZbgAbvs
extern int SetupJoypad( void )
{
	// 
	if( InputSysData.InitializeFlag == FALSE )
	{
		return -1 ;
	}

	// ˑ
	if( SetupJoypad_PF() != 0 )
	{
		return -1 ;
	}

	DXST_LOGFILE_ADDUTF16LE( "\xb8\x30\xe7\x30\xa4\x30\xd1\x30\xc3\x30\xc9\x30\x6e\x30\x1d\x52\x1f\x67\x16\x53\x6f\x30\x63\x6b\x38\x5e\x6b\x30\x42\x7d\x86\x4e\x57\x30\x7e\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"WCpbh̏͐ɏI܂\n" @*/ ) ;

	// I
	return 0 ;
}

// WCpbȟns
extern int TerminateJoypad( void )
{
	// 
	if( InputSysData.InitializeFlag == FALSE )
	{
		return -1 ;
	}

	// ˑ
	if( TerminateJoypad_PF() != 0 )
	{
		return -1 ;
	}

	// I
	return 0 ;
}









// F10 ꂽƂɂtO𗧂Ă
extern int SetF10Input( void )
{
	InputSysData.F10Flag = TRUE ;
//	InputSysData.F10InputTime = NS_GetNowCount() ;

	// I
	return 0 ;
}

// F10 ꂽƂɂtO𗧂Ă
extern int ResetF10Input( void )
{
	InputSysData.F10Flag = FALSE ;

	// I
	return 0 ;
}

// F12 ꂽƂɂtO𗧂Ă
extern int SetF12Input( void )
{
	InputSysData.F12Flag = TRUE ;
//	InputSysData.F12InputTime = NS_GetNowCount() ;

	// I
	return 0 ;
}

// F12 ꂽƂɂtO𗧂Ă
extern int ResetF12Input( void )
{
	InputSysData.F12Flag = FALSE ;

	// I
	return 0 ;
}











// }EX֌W̊֐

// }EẌʒu擾
extern int NS_GetMousePoint( int *XBuf, int *YBuf )
{
//	// ^b`pl̓͂ꍇ͂}EX|C^̈ʒuƂ
//	if( InputSysData.Touch.NowData.PointNum > 0 && InputSysData.Touch.MouseInputID >= 0 )
//	{
//		if( XBuf != NULL )
//		{
//			*XBuf = InputSysData.Touch.NowData.Point[ InputSysData.Touch.MouseInputIndex ].PositionX ;
//		}
//
//		if( YBuf != NULL )
//		{
//			*YBuf = InputSysData.Touch.NowData.Point[ InputSysData.Touch.MouseInputIndex ].PositionY ;
//		}
//	}
//	else
	{
		// ȊȌꍇ͊ˑ̃}EX擾s
		return GetMousePoint_PF( XBuf, YBuf ) ;
	}

	// I
	return 0 ;
}

// }EẌʒuZbg
extern int NS_SetMousePoint( int PointX , int PointY )
{
	// ˑs
	return SetMousePoint_PF( PointX, PointY ) ;
}

// }EX̃{^̏Ԃ𓾂 
extern int NS_GetMouseInput( void )
{
	int MInput ;

	// ˑs
	MInput = GetMouseInput_PF() ;

//	// ^b`pl̓͂ꍇ͍NbNĂ邱Ƃɂ
//	if( InputSysData.Touch.NowData.PointNum > 0 && InputSysData.Touch.MouseInputID >= 0 )
//	{
//		MInput |= MOUSE_INPUT_LEFT ;
//	}
	
	return MInput ;
}

// }EXzC[̉]ʂ𓾂
extern int NS_GetMouseWheelRotVol( int CounterReset )
{
	return GetMouseWheelRotVol_PF( CounterReset ) ;
}

// }EXzC[̉]ʂ𓾂
extern int NS_GetMouseHWheelRotVol( int CounterReset )
{
	return GetMouseHWheelRotVol_PF( CounterReset ) ;
}

// }EXzC[̉]ʂ𓾂( ߂l float ^ )
extern float NS_GetMouseWheelRotVolF( int CounterReset )
{
	return GetMouseWheelRotVolF_PF( CounterReset ) ;
}

// }EXzC[̉]ʂ𓾂( ߂l float ^ )
extern float NS_GetMouseHWheelRotVolF( int CounterReset )
{
	return GetMouseHWheelRotVolF_PF( CounterReset ) ;
}














// ^b`pl֌W̊֐

// ꂽ^b`ǉ
static void AddTouchDownInputPointLog( TOUCHINPUTPOINT *TouchPointData )
{
	int AddIndex ;

	// ̐ő吔𒴂Ă擪f[^̃CfbNX炷
	if( InputSysData.Touch.DownLogNum == INPUTTOUCH_LOG_NUM )
	{
		AddIndex = InputSysData.Touch.DownLogStartIndex ;

		InputSysData.Touch.DownLogStartIndex ++ ;
		if( InputSysData.Touch.DownLogStartIndex == INPUTTOUCH_LOG_NUM )
		{
			InputSysData.Touch.DownLogStartIndex = 0 ;
		}
	}
	else
	{
		AddIndex = InputSysData.Touch.DownLogStartIndex + InputSysData.Touch.DownLogNum ;
		if( AddIndex >= INPUTTOUCH_LOG_NUM )
		{
			AddIndex -= INPUTTOUCH_LOG_NUM ;
		}

		InputSysData.Touch.DownLogNum ++ ;
	}

	// ꂽ^b`Zbg
	InputSysData.Touch.DownLog[ AddIndex ] = *TouchPointData ;
}

// ꂽ^b`ǉ
static void AddTouchUpInputPointLog( TOUCHINPUTPOINT *TouchPointData )
{
	int AddIndex ;

	// ̐ő吔𒴂Ă擪f[^̃CfbNX炷
	if( InputSysData.Touch.UpLogNum == INPUTTOUCH_LOG_NUM )
	{
		AddIndex = InputSysData.Touch.UpLogStartIndex ;

		InputSysData.Touch.UpLogStartIndex ++ ;
		if( InputSysData.Touch.UpLogStartIndex == INPUTTOUCH_LOG_NUM )
		{
			InputSysData.Touch.UpLogStartIndex = 0 ;
		}
	}
	else
	{
		AddIndex = InputSysData.Touch.UpLogStartIndex + InputSysData.Touch.UpLogNum ;
		if( AddIndex >= INPUTTOUCH_LOG_NUM )
		{
			AddIndex -= INPUTTOUCH_LOG_NUM ;
		}

		InputSysData.Touch.UpLogNum ++ ;
	}

	// ꂽ^b`Zbg
	InputSysData.Touch.UpLog[ AddIndex ] = *TouchPointData ;
}

// ^b`pl̓͏Oɒǉ
static void AddTouchInputLog( TOUCHINPUTDATA *TouchData )
{
	int AddIndex ;

	// ^b`̐ő吔𒴂Ă擪f[^̃CfbNX炷
	if( InputSysData.Touch.LogNum == INPUTTOUCH_LOG_NUM )
	{
		AddIndex = InputSysData.Touch.LogStartIndex ;

		InputSysData.Touch.LogStartIndex ++ ;
		if( InputSysData.Touch.LogStartIndex == INPUTTOUCH_LOG_NUM )
		{
			InputSysData.Touch.LogStartIndex = 0 ;
		}
	}
	else
	{
		AddIndex = InputSysData.Touch.LogStartIndex + InputSysData.Touch.LogNum ;
		if( AddIndex >= INPUTTOUCH_LOG_NUM )
		{
			AddIndex -= INPUTTOUCH_LOG_NUM ;
		}

		InputSysData.Touch.LogNum ++ ;
	}

	// f[^Zbg
	InputSysData.Touch.Log[ AddIndex ] = *TouchData ;
}

// ^b`pl̓͏ǉ
extern	int AddTouchInputData( TOUCHINPUTDATA *TouchData )
{
	int i ;
	int j ;

	// ŏ̃^b`񂾂uꂽvOɒǉ
	if( InputSysData.Touch.LogNum == 0 )
	{
		for( i = 0 ; i < TouchData->PointNum ; i ++ )
		{
			AddTouchUpInputPointLog( &TouchData->Point[ i ] ) ;
		}
	}
	else
	{
		// ÕOł݂͑Ȃ^b`烍Oɒǉ
		for( i = 0 ; i < TouchData->PointNum ; i ++ )
		{
			for( j = 0 ; j < InputSysData.Touch.NowData.PointNum ; j ++ )
			{
				if( TouchData->Point[ i ].ID == InputSysData.Touch.NowData.Point[ j ].ID )
				{
					break ;
				}
			}
			if( j != InputSysData.Touch.NowData.PointNum )
			{
				continue ;
			}

			AddTouchUpInputPointLog( &TouchData->Point[ i ] ) ;
		}
	}

	// ÕOƔrāAꂽ^b`烍Oɒǉ
	if( InputSysData.Touch.LogNum >= 1 )
	{
		for( i = 0 ; i < InputSysData.Touch.NowData.PointNum ; i ++ )
		{
			for( j = 0 ; j < TouchData->PointNum ; j ++ )
			{
				if( InputSysData.Touch.NowData.Point[ i ].ID == TouchData->Point[ j ].ID )
				{
					break ;
				}
			}
			if( j != TouchData->PointNum )
			{
				continue ;
			}

			AddTouchUpInputPointLog( &InputSysData.Touch.NowData.Point[ i ] ) ;
		}
	}

	// Oɒǉ
	AddTouchInputLog( TouchData ) ;

	// ŐṼ^b`ɂZbg
	InputSysData.Touch.NowData = *TouchData ;

	// }EX͂Ƃ^b`̂hcXV
	{
		// ^b`񂪂Ȃ -1 
		if( TouchData->PointNum == 0 )
		{
			InputSysData.Touch.MouseInputDevice = -1 ;
			InputSysData.Touch.MouseInputID = -1 ;
			InputSysData.Touch.MouseInputIndex = -1 ;
		}
		else
		{
			// ܂łƓhcXV
			for( i = 0 ; i < TouchData->PointNum ; i ++ )
			{
				if( InputSysData.Touch.MouseInputDevice == TouchData->Point[ i ].Device &&
					InputSysData.Touch.MouseInputID     == TouchData->Point[ i ].ID )
				{
					InputSysData.Touch.MouseInputIndex = i ;
					break ;
				}
			}
			if( i == TouchData->PointNum )
			{
				InputSysData.Touch.MouseInputDevice = TouchData->Point[ 0 ].Device ;
				InputSysData.Touch.MouseInputID     = TouchData->Point[ 0 ].ID ;
				InputSysData.Touch.MouseInputIndex  = 0 ;
			}
		}
	}

	// I
	return 0 ;
}

// ^b`pl͊֌W֐

// ^b`Ă鐔擾
extern int NS_GetTouchInputNum( void )
{
	return InputSysData.Touch.NowData.PointNum ;
}

// ^b`̏擾
extern int NS_GetTouchInput( int InputNo, int *PositionX, int *PositionY, int *ID , int *Device )
{
	if( InputNo >= InputSysData.Touch.NowData.PointNum )
	{
		return -1 ;
	}

	if( PositionX != NULL )
	{
		*PositionX = InputSysData.Touch.NowData.Point[ InputNo ].PositionX ;
	}

	if( PositionY != NULL )
	{
		*PositionY = InputSysData.Touch.NowData.Point[ InputNo ].PositionY ;
	}

	if( ID != NULL )
	{
		*ID = InputSysData.Touch.NowData.Point[ InputNo ].ID ;
	}

	if( Device != NULL )
	{
		*Device = InputSysData.Touch.NowData.Point[ InputNo ].Device ;
	}

	return 0 ;
}

// XgbNĂ^b`̐擾
extern int NS_GetTouchInputLogNum( void )
{
	return InputSysData.Touch.LogNum ;
}

// XgbNĂ^b`NA
extern int NS_ClearTouchInputLog( void )
{
	InputSysData.Touch.LogNum = 0 ;
	InputSysData.Touch.LogStartIndex = 0 ;

	return 0 ;
}

// XgbNĂ^b`񂩂ԌÂЂƂ擾
extern TOUCHINPUTDATA NS_GetTouchInputLogOne( int PeekFlag )
{
	TOUCHINPUTDATA Return ;

	if( InputSysData.Touch.LogNum == 0 )
	{
		_MEMSET( &Return, 0, sizeof( Return ) ) ;
	}
	else
	{
		Return = InputSysData.Touch.Log[ InputSysData.Touch.LogStartIndex ] ;

		if( PeekFlag == FALSE )
		{
			InputSysData.Touch.LogStartIndex ++ ;
			if( InputSysData.Touch.LogStartIndex == INPUTTOUCH_LOG_NUM )
			{
				InputSysData.Touch.LogStartIndex = 0 ;
			}

			InputSysData.Touch.LogNum -- ;
		}
	}

	return Return ;
}

// XgbNĂ^b`񂩂ÂɎw萔obt@Ɏ擾( ߂l  -1:G[  0ȏ:擾̐ )
extern int NS_GetTouchInputLog( TOUCHINPUTDATA *TouchData, int GetNum, int PeekFlag )
{
	int i ;
	int GetIndex ;

	if( InputSysData.Touch.LogNum == 0 )
	{
		return 0 ;
	}

	if( InputSysData.Touch.LogNum < GetNum )
	{
		GetNum = InputSysData.Touch.LogNum ;
	}

	GetIndex = InputSysData.Touch.LogStartIndex ;
	for( i = 0 ; i < GetNum ; i ++ )
	{
		TouchData[ i ] = InputSysData.Touch.Log[ GetIndex ] ;

		GetIndex ++ ;
		if( GetIndex == INPUTTOUCH_LOG_NUM )
		{
			GetIndex = 0 ;
		}
	}

	if( PeekFlag == FALSE )
	{
		InputSysData.Touch.LogNum -= GetNum ;
		InputSysData.Touch.LogStartIndex = GetIndex ;
	}

	return GetNum ;
}







// XgbNĂ^b`n߂̐擾
extern int NS_GetTouchInputDownLogNum( void )
{
	return InputSysData.Touch.DownLogNum ;
}

// XgbNĂ^b`n߂NA
extern int NS_ClearTouchInputDownLog( void )
{
	InputSysData.Touch.DownLogNum = 0 ;
	InputSysData.Touch.DownLogStartIndex = 0 ;

	return 0 ;
}

// XgbNĂ^b`n߂񂩂ԌÂЂƂ擾
extern TOUCHINPUTPOINT NS_GetTouchInputDownLogOne( int PeekFlag )
{
	TOUCHINPUTPOINT Return ;

	if( InputSysData.Touch.DownLogNum == 0 )
	{
		_MEMSET( &Return, 0, sizeof( Return ) ) ;
	}
	else
	{
		Return = InputSysData.Touch.DownLog[ InputSysData.Touch.DownLogStartIndex ] ;

		if( PeekFlag == FALSE )
		{
			InputSysData.Touch.DownLogStartIndex ++ ;
			if( InputSysData.Touch.DownLogStartIndex == INPUTTOUCH_LOG_NUM )
			{
				InputSysData.Touch.DownLogStartIndex = 0 ;
			}

			InputSysData.Touch.DownLogNum -- ;
		}
	}

	return Return ;
}

// XgbNĂ^b`n߂񂩂ÂɎw萔obt@Ɏ擾( ߂l  -1:G[  0ȏ:擾̐ )
extern int NS_GetTouchInputDownLog( TOUCHINPUTPOINT *TouchData, int GetNum, int PeekFlag )
{
	int i ;
	int GetIndex ;

	if( InputSysData.Touch.DownLogNum == 0 )
	{
		return 0 ;
	}

	if( InputSysData.Touch.DownLogNum < GetNum )
	{
		GetNum = InputSysData.Touch.DownLogNum ;
	}

	GetIndex = InputSysData.Touch.DownLogStartIndex ;
	for( i = 0 ; i < GetNum ; i ++ )
	{
		TouchData[ i ] = InputSysData.Touch.DownLog[ GetIndex ] ;

		GetIndex ++ ;
		if( GetIndex == INPUTTOUCH_LOG_NUM )
		{
			GetIndex = 0 ;
		}
	}

	if( PeekFlag == FALSE )
	{
		InputSysData.Touch.DownLogNum -= GetNum ;
		InputSysData.Touch.DownLogStartIndex = GetIndex ;
	}

	return GetNum ;
}











// XgbNĂ^b`ꂽ̐擾
extern int NS_GetTouchInputUpLogNum( void )
{
	return InputSysData.Touch.UpLogNum ;
}

// XgbNĂ^b`ꂽNA
extern int NS_ClearTouchInputUpLog( void )
{
	InputSysData.Touch.UpLogNum = 0 ;
	InputSysData.Touch.UpLogStartIndex = 0 ;

	return 0 ;
}

// XgbNĂ^b`ꂽ񂩂ԌÂЂƂ擾
extern TOUCHINPUTPOINT NS_GetTouchInputUpLogOne( int PeekFlag )
{
	TOUCHINPUTPOINT Return ;

	if( InputSysData.Touch.UpLogNum == 0 )
	{
		_MEMSET( &Return, 0, sizeof( Return ) ) ;
	}
	else
	{
		Return = InputSysData.Touch.UpLog[ InputSysData.Touch.UpLogStartIndex ] ;

		if( PeekFlag == FALSE )
		{
			InputSysData.Touch.UpLogStartIndex ++ ;
			if( InputSysData.Touch.UpLogStartIndex == INPUTTOUCH_LOG_NUM )
			{
				InputSysData.Touch.UpLogStartIndex = 0 ;
			}

			InputSysData.Touch.UpLogNum -- ;
		}
	}

	return Return ;
}

// XgbNĂ^b`ꂽ񂩂ÂɎw萔obt@Ɏ擾( ߂l  -1:G[  0ȏ:擾̐ )
extern int NS_GetTouchInputUpLog( TOUCHINPUTPOINT *TouchData, int GetNum, int PeekFlag )
{
	int i ;
	int GetIndex ;

	if( InputSysData.Touch.UpLogNum == 0 )
	{
		return 0 ;
	}

	if( InputSysData.Touch.UpLogNum < GetNum )
	{
		GetNum = InputSysData.Touch.UpLogNum ;
	}

	GetIndex = InputSysData.Touch.UpLogStartIndex ;
	for( i = 0 ; i < GetNum ; i ++ )
	{
		TouchData[ i ] = InputSysData.Touch.UpLog[ GetIndex ] ;

		GetIndex ++ ;
		if( GetIndex == INPUTTOUCH_LOG_NUM )
		{
			GetIndex = 0 ;
		}
	}

	if( PeekFlag == FALSE )
	{
		InputSysData.Touch.UpLogNum -= GetNum ;
		InputSysData.Touch.UpLogStartIndex = GetIndex ;
	}

	return GetNum ;
}

















// ͏Ԏ擾֐

// L[{[h̏Ԏ擾
extern int NS_CheckHitKey( int KeyCode )
{
	int Result ;

	// \tgANeBȕꍇ̓ANeBuɂȂ܂ő҂
	CheckActiveState() ;

	// ĂȂtŏs
	if( InputSysData.InitializeFlag == FALSE )
	{
		return AutoInitialize_PF() ;
	}

	// L[{[h̓͏ԂXV
	UpdateKeyboardInputState() ;

	// w̃L[̏ԂԂ
	Result = ( InputSysData.KeyInputBuf[ KeyCode ] & 0x80 ) != 0 ;
	
	return Result ;
}

// SL[̉Ԃ擾
extern int NS_CheckHitKeyAll( int CheckType )
{
	int i ;
	unsigned char *KeyData ;

#ifdef __WINDOWS__
	if( WinData.MainWindow == NULL )
		return -1 ;
#endif // __WINDOWS__

	// \tgANeBȕꍇ̓ANeBuɂȂ܂ő҂
	CheckActiveState() ;

	// ĂȂtŏs
	if( InputSysData.InitializeFlag == FALSE )
	{
		return AutoInitialize_PF() ;
	}

	// L[{[h̃`FbN
	if( CheckType & DX_CHECKINPUT_KEY )
	{
		// L[{[h̓͏ԂXV
		UpdateKeyboardInputState() ;

		// ǂꂩłL[Ă邩
		KeyData = InputSysData.KeyInputBuf ;
		for( i = 0 ; i < 256 ; i ++ , KeyData ++ )
		{
			if( ( *KeyData & 0x80 ) && i != KEY_INPUT_KANJI && i != KEY_INPUT_CAPSLOCK && i != KEY_INPUT_KANA )
				return i ;
		}
		if( InputSysData.F10Flag )
		{
			return KEY_INPUT_F10 ;
		}
	}

	// WCpbh̃`FbN
	if( CheckType & DX_CHECKINPUT_PAD )
	{
		for( i = 0 ; i < InputSysData.PadNum ; i ++ )
		{
			if( NS_GetJoypadInputState( i + 1 ) != 0 )
				return -1 ;
		}
	}

	// }EX{^̃`FbN
	if( CheckType & DX_CHECKINPUT_MOUSE )
	{
#ifdef __WINDOWS__
		int x, y ;
		RECT Rect ;

		NS_GetMousePoint( &x, &y ) ;

		NS_GetWindowCRect( &Rect ) ;
		if( x >= 0                      && y >= 0                      && NS_GetWindowActiveFlag() &&
			x <= Rect.right - Rect.left && y <= Rect.bottom - Rect.top && NS_GetMouseInput() != 0 )
			return -1 ;
#else // __WINDOWS__
		if( NS_GetMouseInput() != 0 )
		{
			return -1 ;
		}
#endif // __WINDOWS__
	}

	// I
	return 0 ;
}

// ׂẴL[̉Ԃ擾
extern int NS_GetHitKeyStateAll( char *KeyStateBuf )
{
	int i ;

	// \tgANeBȕꍇ̓ANeBuɂȂ܂ő҂
	CheckActiveState() ;

	// ĂȂtŏs
	if( InputSysData.InitializeFlag == FALSE )
	{
		return AutoInitialize_PF() ;
	}

	// L[{[h̓͏ԂXV
	UpdateKeyboardInputState() ;

	// L[̓͒lϊ
	for( i = 0 ; i < 256 ; i ++ , KeyStateBuf ++ )
	{
		*KeyStateBuf = ( BYTE )( InputSysData.KeyInputBuf[i] ) >> 7 ;
	}

	// I
	return 0 ;
}





// WCpbhڑĂ鐔擾
extern int NS_GetJoypadNum( void )
{
	// \tgANeBȕꍇ̓ANeBuɂȂ܂ő҂
	CheckActiveState() ;

	// ĂȂtŏs
	if( InputSysData.InitializeFlag == FALSE )
	{
		return AutoInitialize_PF() ;
	}

	return InputSysData.PadNum ;
}

// WCobh̓͏Ԏ擾
extern int NS_GetJoypadInputState( int InputType )
{
	int BackData = 0 ;
	INPUTPADDATA *pad ;
	int JoypadNum = ( InputType & ~DX_INPUT_KEY ) - 1 ;
	int iX , iY ;

	// \tgANeBȕꍇ̓ANeBuɂȂ܂ő҂
	CheckActiveState() ;

	// ĂȂtŏs
	if( InputSysData.InitializeFlag == FALSE )
	{
		return AutoInitialize_PF() ;
	}

	if( ( JoypadNum < -1 || JoypadNum >= InputSysData.PadNum ) && 
		( InputSysData.PadNum != 0 && ( InputType & DX_INPUT_KEY ) == 0 ) )
	{
		return 0 ;
	}

	if( JoypadNum != -1 && InputSysData.PadNum != 0 && JoypadNum < InputSysData.PadNum )
	{
		pad = &InputSysData.Pad[ JoypadNum ] ;

		// pbh̏擾
		{
			// ̍XV
			UpdateJoypadInputState( JoypadNum ) ;

			// ͏Ԃۑ
			iX = pad->State.X ;
			iY = pad->State.Y ;

			// J[\{^
			     if( iX < 0 ) BackData |= PAD_INPUT_LEFT ;			// ͔
			else if( iX > 0 ) BackData |= PAD_INPUT_RIGHT ;			// ͔

			     if( iY < 0 ) BackData |= PAD_INPUT_UP ;			// ͔
			else if( iY > 0 ) BackData |= PAD_INPUT_DOWN ;			// ͔

			// nbgXCb`̏Ԃ{^ɔf
			switch( pad->State.POV[ 0 ] )
			{
			case 0 :		BackData |= PAD_INPUT_UP						;	break ;
			case 4500 :		BackData |= PAD_INPUT_UP    | PAD_INPUT_RIGHT	;	break ;
			case 9000 :		BackData |= PAD_INPUT_RIGHT						;	break ;
			case 13500 :	BackData |= PAD_INPUT_RIGHT | PAD_INPUT_DOWN	;	break ;
			case 18000 :	BackData |= PAD_INPUT_DOWN						;	break ;
			case 22500 :	BackData |= PAD_INPUT_DOWN  | PAD_INPUT_LEFT	;	break ;
			case 27000 :	BackData |= PAD_INPUT_LEFT						;	break ;
			case 31500 :	BackData |= PAD_INPUT_LEFT  | PAD_INPUT_UP		;	break ;
			}

			// {^͔
			{
				int i ;

				// ͏Ԃۑ
				for( i = 0 ; i < 24 ; i ++ )
				{
					BackData |= ( pad->State.Buttons[ i ] & 0x80 ) != 0 ? 1 << ( i + 4 ) : 0 ;
				}
			}
		}
	}

	// L[͎wꍇ̓L[̓͏Ԃf
	if( InputType & DX_INPUT_KEY )
	{
		BYTE *KeyBuf ;
		int *Map ;
		int i, j ;
		unsigned int pad ;

		// L[{[h̓͏ԂXV
		UpdateKeyboardInputState() ;

		KeyBuf = InputSysData.KeyInputBuf ;
		Map = InputSysData.KeyToJoypadInput[ JoypadNum < 0 ? 0 : JoypadNum ][ 0 ] ;

		pad = 1 ;
		for( i = 0 ; i < 32 ; i ++, pad <<= 1, Map += 4 )
		{
			for( j = 0 ; j < 4 ; j ++ )
			{
				if( Map[ j ] > 0 && ( KeyBuf[ Map[ j ] ] & 0x80 ) )
				{
					BackData |= ( int )pad ;
					break ; 
				}
			}
		}
	}

	// I
	return BackData ;
}

// WCpbh̃AiOIȃXeBbN͏𓾂
extern int NS_GetJoypadAnalogInput( int *XBuf , int *YBuf , int InputType )
{
	int BackData = 0 ;
	INPUTPADDATA *pad ;
	int JoypadNum = ( InputType & ~DX_INPUT_KEY ) - 1 ;

	// \tgANeBȕꍇ̓ANeBuɂȂ܂ő҂
	CheckActiveState() ;
	
	if( XBuf != NULL ) *XBuf = 0 ;
	if( YBuf != NULL ) *YBuf = 0 ;

	// ĂȂtŏs
	if( InputSysData.InitializeFlag == FALSE )
	{
		return AutoInitialize_PF() ;
	}

	if( ( JoypadNum < -1 || JoypadNum >= InputSysData.PadNum ) && 
		( InputSysData.PadNum != 0 && ( InputType & DX_INPUT_KEY ) == 0 ) )
	{
		return 0 ;
	}

	if( JoypadNum != -1 && InputSysData.PadNum != 0 )
	{
		pad = &InputSysData.Pad[ JoypadNum ] ;

		// ͏Ԃ̍XV
		UpdateJoypadInputState( JoypadNum ) ;

		// ͏Ԃۑ
		if( XBuf ) *XBuf = pad->State.X ;
		if( YBuf ) *YBuf = pad->State.Y ;
	}

	// L[͎wꍇ̓L[̓͏Ԃf
	if( InputType & DX_INPUT_KEY )
	{
		BYTE *KeyBuf ;

		// L[{[h̓͏ԂXV
		UpdateKeyboardInputState() ;

		KeyBuf = InputSysData.KeyInputBuf ;
		if( XBuf )
		{
			if( KeyBuf[ KEY_INPUT_NUMPAD4 ] & 0x80 || KeyBuf[ KEY_INPUT_LEFT  ] & 0x80 ) *XBuf = -DIRINPUT_MAX ;		// SL[`FbN
			if( KeyBuf[ KEY_INPUT_NUMPAD6 ] & 0x80 || KeyBuf[ KEY_INPUT_RIGHT ] & 0x80 ) *XBuf =  DIRINPUT_MAX	;		// UL[L[`FbN
		}
		if( YBuf )
		{
			if( KeyBuf[ KEY_INPUT_NUMPAD2 ] & 0x80 || KeyBuf[ KEY_INPUT_DOWN  ] & 0x80 ) *YBuf =  DIRINPUT_MAX	;		// QL[L[`FbN
			if( KeyBuf[ KEY_INPUT_NUMPAD8 ] & 0x80 || KeyBuf[ KEY_INPUT_UP    ] & 0x80 ) *YBuf = -DIRINPUT_MAX ;		// WL[L[`FbN
		}
	}

	// I
	return BackData ;
}

// WCpbh̃AiOIȃXeBbN͏𓾂(EXeBbNp)
extern int NS_GetJoypadAnalogInputRight( int *XBuf, int *YBuf, int InputType )
{
	int BackData = 0 ;
	INPUTPADDATA *pad ;
	int JoypadNum = ( InputType & ~DX_INPUT_KEY ) - 1 ;

	// \tgANeBȕꍇ̓ANeBuɂȂ܂ő҂
	CheckActiveState() ;
	
	if( XBuf != NULL ) *XBuf = 0 ;
	if( YBuf != NULL ) *YBuf = 0 ;

	// ĂȂtŏs
	if( InputSysData.InitializeFlag == FALSE )
	{
		return AutoInitialize_PF() ;
	}

	if( JoypadNum < -1 || JoypadNum >= InputSysData.PadNum )
		return 0 ;

	if( JoypadNum != -1 )
	{
		pad = &InputSysData.Pad[ JoypadNum ] ;

		// ͏Ԃ̍XV
		UpdateJoypadInputState( JoypadNum ) ;

		// ͏Ԃۑ( XInput ǂŏ𕪊 )
		if( NS_CheckJoypadXInput( InputType ) )
		{
			if( XBuf ) *XBuf = pad->State.Rx ;
			if( YBuf ) *YBuf = pad->State.Ry ;
		}
		else
		{
			if( XBuf ) *XBuf = pad->State.Z ;
			if( YBuf ) *YBuf = pad->State.Rz ;
		}
	}

	// I
	return BackData ;
}

// WCpbh DirectInput 瓾鐶̃f[^擾( DX_CHECKINPUT_KEY  DX_INPUT_KEY_PAD1 ɓnƃG[ )
extern	int	NS_GetJoypadDirectInputState( int InputType, DINPUT_JOYSTATE *DInputState )
{
	INPUTPADDATA *pad ;
	int JoypadNum = ( InputType & ~DX_INPUT_KEY ) - 1 ;

	// \tgANeBȕꍇ̓ANeBuɂȂ܂ő҂
	CheckActiveState() ;

	// ĂȂtŏs
	if( InputSysData.InitializeFlag == FALSE )
	{
		return AutoInitialize_PF() ;
	}

	if( JoypadNum < 0 || JoypadNum >= InputSysData.PadNum )
	{
		_MEMSET( DInputState, 0, sizeof( DINPUT_JOYSTATE ) ) ;
		DInputState->POV[ 0 ] = 0xffffffff ;
		DInputState->POV[ 1 ] = 0xffffffff ;
		DInputState->POV[ 2 ] = 0xffffffff ;
		DInputState->POV[ 3 ] = 0xffffffff ;
		return -1 ;
	}

	pad = &InputSysData.Pad[ JoypadNum ] ;

	// ͏Ԃ̍XV
	UpdateJoypadInputState( JoypadNum ) ;

	// ͏Ԃ
	if( DInputState )
	{
		*DInputState = pad->State ;
	}

	// I
	return 0 ;
}

// w̓̓foCX XInput ɑΉĂ邩ǂ擾
// ( ߂l  TRUE:XInputΉ̓̓foCX  FALSE:XInputΉ̓̓foCX   -1:G[ )
// ( DX_INPUT_KEY  DX_INPUT_KEY_PAD1 ȂǁAL[{[hރ^Cv InputType ɓnƃG[ƂȂ -1 Ԃ )
extern int NS_CheckJoypadXInput( int InputType )
{
	int JoypadNum = ( InputType & ~DX_INPUT_KEY ) - 1 ;

	// \tgANeBȕꍇ̓ANeBuɂȂ܂ő҂
	CheckActiveState() ;

	// ĂȂtŏs
	if( InputSysData.InitializeFlag == FALSE )
	{
		return AutoInitialize_PF() ;
	}

	if( JoypadNum < 0 || JoypadNum >= InputSysData.PadNum )
	{
		return -1 ;
	}

	// ˑɔC
	return CheckJoypadXInput_PF( InputType ) ;
}

// XInput 瓾̓foCX( Xbox360Rg[ )̐̃f[^擾( XInputΉ̃pbh̏ꍇ̓G[ƂȂ -1 ԂADX_INPUT_KEY  DX_INPUT_KEY_PAD1 ȂǁAL[{[hރ^Cv InputType ɓnƃG[ƂȂ -1 Ԃ )
extern int NS_GetJoypadXInputState(	int InputType, XINPUT_STATE *XInputState )
{
	INPUTPADDATA *pad ;
	int JoypadNum = ( InputType & ~DX_INPUT_KEY ) - 1 ;

	// \tgANeBȕꍇ̓ANeBuɂȂ܂ő҂
	CheckActiveState() ;

	// ĂȂtŏs
	if( InputSysData.InitializeFlag == FALSE )
	{
		return AutoInitialize_PF() ;
	}

	if( JoypadNum < 0 || JoypadNum >= InputSysData.PadNum )
	{
		_MEMSET( XInputState, 0, sizeof( XINPUT_STATE ) ) ;
		return -1 ;
	}

	pad = &InputSysData.Pad[ JoypadNum ] ;

	// XInput ɑΉĂȂG[
	if( NS_CheckJoypadXInput( InputType ) == FALSE )
	{
		_MEMSET( XInputState, 0, sizeof( XINPUT_STATE ) ) ;
		return -1 ;
	}

	// ͏Ԃ̍XV
	UpdateJoypadInputState( JoypadNum ) ;

	// ͏Ԃ
	if( XInputState )
	{
		*XInputState = pad->XInputState ;
	}

	// I
	return 0 ;
}

// WCpbh̓͂ɑΉL[{[h̓͂ݒ肷
extern	int NS_SetJoypadInputToKeyInput( int InputType, int PadInput, int KeyInput1, int KeyInput2 , int KeyInput3 , int KeyInput4 )
{
	unsigned int Bit , i ;

	int JoypadNum = ( InputType & ~DX_INPUT_KEY ) - 1 ;

	if( JoypadNum < 0 || JoypadNum >= MAX_JOYPAD_NUM )
		return 0 ;

	Bit = (unsigned int)PadInput ;
	for( i = 0 ; i < 32 ; i ++ )
	{
		if( Bit & ( 1 << i ) )
		{
			InputSysData.KeyToJoypadInput[ JoypadNum ][ i ][ 0 ] = KeyInput1 ;
			InputSysData.KeyToJoypadInput[ JoypadNum ][ i ][ 1 ] = KeyInput2 ;
			InputSysData.KeyToJoypadInput[ JoypadNum ][ i ][ 2 ] = KeyInput3 ;
			InputSysData.KeyToJoypadInput[ JoypadNum ][ i ][ 3 ] = KeyInput4 ;
		}
	}

	// I
	return 0 ;
}

// WCpbh̖][̐ݒs
extern	int NS_SetJoypadDeadZone( int InputType, double Zone )
{
	int JoypadNum = ( InputType & ~DX_INPUT_KEY ) - 1 ;
	INPUTPADDATA *pad = &InputSysData.Pad[ JoypadNum ] ;
	DWORD ZoneI ;

	// \tgANeBȕꍇ̓ANeBuɂȂ܂ő҂
	CheckActiveState() ;
	
	// ĂȂtŏs
	if( InputSysData.InitializeFlag == FALSE )
	{
		return AutoInitialize_PF() ;
	}

	// G[`FbN
	if( JoypadNum < 0 || JoypadNum >= InputSysData.PadNum )
	{
		return 0 ;
	}

	// ܂łƓ][̏ꍇ͉I
	ZoneI = ( DWORD )_DTOL( Zone * 65536 ) ;
	if( pad->DeadZone == ZoneI )
	{
		pad->DeadZoneD = Zone ;
		return 0 ;
	}

	// ][ۑ
	pad->DeadZone = ZoneI ;
	pad->DeadZoneD = Zone ;

	// ˑ
	SetJoypadDeadZone_PF( pad ) ;

	// I
	return 0 ;
}

// WCpbh̖][̐ݒ擾( InputType:ݒύXpbh̎ʎq( DX_INPUT_PAD1 )   ߂l:][( 0.0 ` 1.0 )
extern	double NS_GetJoypadDeadZone( int InputType )
{
	INPUTPADDATA *pad ;
	int JoypadNum = ( InputType & ~DX_INPUT_KEY ) - 1 ;

	// \tgANeBȕꍇ̓ANeBuɂȂ܂ő҂
	CheckActiveState() ;

	// ĂȂtŏs
	if( InputSysData.InitializeFlag == FALSE )
	{
		AutoInitialize_PF() ;
	}

	// G[`FbN
	if( JoypadNum < 0 || JoypadNum >= InputSysData.PadNum )
	{
		return -1.0 ;
	}

	pad = &InputSysData.Pad[ JoypadNum ] ;

	// lԂ
	return pad->DeadZoneD ;
}

// WCpbh̐UJn
extern	int NS_StartJoypadVibration( int InputType, int Power, int Time, int EffectIndex )
{
	int               SetPower ;
	int JoypadNum = ( InputType & ~DX_INPUT_KEY ) - 1 ;
	INPUTPADDATA *pad = &InputSysData.Pad[ JoypadNum ] ;

	// \tgANeBȕꍇ̓ANeBuɂȂ܂ő҂
	CheckActiveState() ;

	// ĂȂtŏs
	if( InputSysData.InitializeFlag == FALSE )
	{
		return AutoInitialize_PF() ;
	}

	// G[`FbN
	if( JoypadNum < 0 || JoypadNum >= InputSysData.PadNum )
	{
		return 0 ;
	}

	// EffectIndex }CiX̏ꍇ͏𕪊
	if( EffectIndex < 0 )
	{
		if( Power < 0 )
		{
			NS_StartJoypadVibration( InputType, pad->Effect[ DINPUTPAD_MOTOR_LEFT ].Power, Time, DINPUTPAD_MOTOR_LEFT ) ;
		}
		else
		{
			SetPower = Power * 2 ;
			if( SetPower > DX_FFNOMINALMAX / 10 )
			{
				SetPower = DX_FFNOMINALMAX / 10 ;
			}
			NS_StartJoypadVibration( InputType, SetPower, Time, DINPUTPAD_MOTOR_LEFT ) ;
		}

		if( Power < 0 )
		{
			NS_StartJoypadVibration( InputType, pad->Effect[ DINPUTPAD_MOTOR_RIGHT ].Power, Time, DINPUTPAD_MOTOR_RIGHT ) ;
		}
		else
		{
			SetPower = ( Power - ( DX_FFNOMINALMAX / 10 / 2 ) ) * 2 ;
			if( SetPower <= 0 )
			{
				SetPower = 0 ;
			}
			else
			if( SetPower > DX_FFNOMINALMAX / 10 )
			{
				SetPower = DX_FFNOMINALMAX / 10 ;
			}
			NS_StartJoypadVibration( InputType, SetPower, Time, DINPUTPAD_MOTOR_RIGHT ) ;
		}

		// I
		return 0 ;
	}

	if( EffectIndex >= DINPUTPAD_MOTOR_NUM )
	{
		return 0 ;
	}

	// UɑΉĂȂ΂ŏI
	if( CheckJoypadVibrationEnable_PF( pad, EffectIndex ) == FALSE )
	{
		return 0 ;
	}

	// ̑傫 DirectInput ̌^ɍ킹
	if( Power < 0 )
	{
		Power = pad->Effect[ EffectIndex ].Power ;
	}
	else
	{
		Power *= 10 ;
		if( Power >  DX_FFNOMINALMAX )
		{
			Power =  DX_FFNOMINALMAX ;
		}
	}

	// h̑傫Ȍꍇ͐UXgbv
	if( Power == 0 )
	{
		NS_StopJoypadVibration( InputType, EffectIndex ) ;
	}
	else
	{
		// ĐJnȂǂZbg
		pad->Effect[ EffectIndex ].BackTime	= NS_GetNowCount() ;
		pad->Effect[ EffectIndex ].Time		= Time ;
		pad->Effect[ EffectIndex ].CompTime	= 0 ;

		// ɍĐł̑傫ꍇ͉Ȃ
		if( pad->Effect[ EffectIndex ].PlayFlag == TRUE && pad->Effect[ EffectIndex ].Power == Power )
		{
			return 0 ;
		}

		// Đݒۑ
		pad->Effect[ EffectIndex ].PlayFlag	= TRUE ;
		pad->Effect[ EffectIndex ].Power	= Power ;

		// ĐԂ̐ݒ𔽉f
		RefreshEffectPlayState() ;
	}

	// I
	return 0 ;
}

// WCpbh̐U~
extern	int NS_StopJoypadVibration( int InputType, int EffectIndex )
{
	int JoypadNum = ( InputType & ~DX_INPUT_KEY ) - 1 ;
	INPUTPADDATA *pad = &InputSysData.Pad[ JoypadNum ] ;

	// \tgANeBȕꍇ̓ANeBuɂȂ܂ő҂
	CheckActiveState() ;
	
	// ĂȂtŏs
	if( InputSysData.InitializeFlag == FALSE )
	{
		return AutoInitialize_PF() ;
	}

	// G[`FbN
	if( JoypadNum < 0 || JoypadNum >= InputSysData.PadNum )
	{
		return 0 ;
	}

	// EffectIndex }CiX̏ꍇ͏𕪊
	if( EffectIndex < 0 )
	{
		// E[^[̐U~߂
		NS_StopJoypadVibration( InputType, DINPUTPAD_MOTOR_LEFT ) ;
		NS_StopJoypadVibration( InputType, DINPUTPAD_MOTOR_RIGHT ) ;

		// I
		return 0 ;
	}

	if( EffectIndex >= DINPUTPAD_MOTOR_NUM )
	{
		return 0 ;
	}

	// UɑΉĂȂ΂ŏI
	if( CheckJoypadVibrationEnable_PF( pad, EffectIndex ) == FALSE )
	{
		return 0 ;
	}

	// ɍĐ~Ă牽Ȃ
	if( pad->Effect[ EffectIndex ].PlayFlag == FALSE )
	{
		return 0 ;
	}

	// ĐtO|
	pad->Effect[ EffectIndex ].PlayFlag = FALSE ;

	// Ű
	pad->Effect[ EffectIndex ].Power = DX_FFNOMINALMAX ;

	// ĐԂ̐ݒ𔽉f
	RefreshEffectPlayState() ;

	// I
	return 0 ;
}

// WCpbĥonu͂̏Ԃ𓾂( Pʂ͊px̂POO{  Sʒuɂꍇ -1 Ԃ )
extern int NS_GetJoypadPOVState( int InputType, int POVNumber )
{
	int JoypadNum = ( InputType & ~DX_INPUT_KEY ) - 1 ;
	INPUTPADDATA *pad = &InputSysData.Pad[ JoypadNum ] ;
	DWORD pov;

	// \tgANeBȕꍇ̓ANeBuɂȂ܂ő҂
	CheckActiveState() ;
	
	// ĂȂtŏs
	if( InputSysData.InitializeFlag == FALSE )
	{
		AutoInitialize_PF() ;
		return -1 ;
	}

	// G[`FbN
	if( JoypadNum < 0 || JoypadNum >= InputSysData.PadNum || POVNumber >= 4 )
	{
		return -1 ;
	}

	// ̍XV
	UpdateJoypadInputState( JoypadNum ) ;
	pov = pad->State.POV[ POVNumber ] ;

	// S`FbN
	if( ( pov & 0xffff ) == 0xffff )
	{
		return -1 ;
	}

	// 炩̊pxꍇ͂̂܂ܕԂ
	return ( int )pov ;
}

// WCpbh̍ăZbgAbvs( VɐڑꂽWCpbhꍇɌo )
extern int NS_ReSetupJoypad( void )
{
	// WCpbh̍ăZbgAbvs
	return SetupJoypad() ;
}

// L[{[h̓͏Ԃ̍XV
extern int UpdateKeyboardInputState( int UseProcessMessage )
{
	static BOOL InFunction = FALSE ;
	int Result ;

	// ċAh~
	if( InFunction == TRUE )
	{
		return 0 ;
	}
	InFunction = TRUE ;

	// ˑ
	Result = UpdateKeyboardInputState_PF( UseProcessMessage ) ;

	InFunction = FALSE ;

	return Result ;
}

// pbh̓͏Ԃ̍XV
static int UpdateJoypadInputState( int padno )
{
	int Result ;

	// pbhԍ`FbN
	if( padno < 0 || padno >= MAX_JOYPAD_NUM )
	{
		return -1 ;
	}

	// ˑ
	Result = UpdateJoypadInputState_PF( padno ) ;

	// I
	return Result ;
}

// WCpbh̐U@\gp邩ǂ̃tOZbg
extern int NS_SetUseJoypadVibrationFlag( int Flag )
{
	InputSysData.NoUseVibrationFlag = !Flag ;

	// I
	return 0 ;
}

// pbh̃GtFNgɊւt[s
extern int JoypadEffectProcess( void )
{
	int        i ;
	int        j ;
	int        num ;
	int        time ;
	INPUTPADDATA *Pad ;

	// 
	if( InputSysData.InitializeFlag == FALSE )
	{
		return 0 ;
	}

	// pbhfoCX̍Ď擾
	num = InputSysData.PadNum ;
	Pad = InputSysData.Pad ;
	time = NS_GetNowCount() ;
	for( i = 0 ; i < num ; i ++, Pad ++ )
	{
		for( j = 0 ; j < DINPUTPAD_MOTOR_NUM ; j ++ )
		{
			if( CheckJoypadVibrationEnable_PF( Pad, j ) == FALSE )
			{
				continue ;
			}

			if( Pad->Effect[ j ].PlayFlag == FALSE )
			{
				continue ;
			}

			// Đ̏ꍇ͓ɉȂ
			if( Pad->Effect[ j ].Time < 0 )
			{
				continue ;
			}

			// O񂩂玞ςĂȂ牽Ȃ
			if( Pad->Effect[ j ].BackTime == time )
			{
				continue ;
			}

			// oߎԂ̉Z
			if( time < Pad->Effect[ j ].BackTime )
			{
				Pad->Effect[ j ].BackTime = time ;
			}
			Pad->Effect[ j ].CompTime += time - Pad->Effect[ j ].BackTime ;

			// ̎ۑ
			Pad->Effect[ j ].BackTime = time ;

			// Đ~̃`FbN
			if( Pad->Effect[ j ].CompTime >= Pad->Effect[ j ].Time )
			{
				NS_StopJoypadVibration( i + 1, j ) ;
			}
		}
	}

	// ĐԂ̍XV
	RefreshEffectPlayState() ;

	// I
	return 0 ;
}

// pbhGtFNg̍ĐԂXV(\tgANeBuɂȂ邱Ƃ邽)
extern int RefreshEffectPlayState( void )
{
	// 
	if( InputSysData.InitializeFlag == FALSE )
	{
		return 0 ;
	}

	// ˑ
	RefreshEffectPlayState_PF() ;

	// I
	return 0 ;
}

#ifndef DX_NON_NAMESPACE

}

#endif // DX_NON_NAMESPACE

#endif // DX_NON_INPUT
